/*	@doesc.c - process escape sequences
 */
#include <ctype.h>

short doesc(char **pp, char *magic)
	{
	register short d, n;
	register char *p;

	p = *pp + 1;
	if (*p == '\0')
		return (**pp);
	else if (isdigit(*p))
		{
		for (d = 0, n = 1; isdigit(*p) && n <= 3; ++p, ++n)
			d = (d << 3) + *p - '0';
		*pp = p - 1;
		return (d);
		}
	else if ((d = scnstr("bfnrtv", (char)tolower(*p))) < 5)
		{
		*pp = p;
		return ("\b\f\n\r\t\v"[d]);
		}
	else if (magic && magic[d = scnstr(magic, *p)])
		{
		*pp = p;
		return (-1 - d);
		}
	else
		{
		*pp = p;
		return (*p);
		}
	}
