#include <stdio.h>

usage()
{
	fprintf(stderr, "usage: error");
	exit(9);
}

openerror()
{
	fprintf(stderr, "open: error");
	exit(8);
}

main(int argc, char **argv)
{
	FILE * f1, * f2;
	int c1, c2;
	int diffs = 0;

	if (argc != 3)
		usage();
	if ((f1 = fopen(argv[1], "r")) == NULL)
		openerror();
	if ((f2 = fopen(argv[2], "r")) == NULL)
		openerror();
	while ((c1 = fgetc(f1)) != EOF)
	{
		c2 = fgetc(f2);
		if (c1 != c2)
		{
			printf("%x %x\n", c1, c2);
			diffs++;
		} 
	}
	fprintf(stderr, "Total diffs: %d\n", diffs);
}
		

	
